import React from 'react';
import styled from 'styled-components';
import background from 'static/resultbackground.png';

const StyledWrapper = styled.div`
  margin-bottom: 150px;
`;

const StyledSearchWrapper = styled.section`
  background-image: url(${background});
  background-size: 100% 100%;
  text-align: center;
  padding: 5vh 0;
  margin: 0 10px;
`;

const StyledResultWrapper = styled.article`
  margin: 0 50px 50px 50px;
  display: grid;
  grid-gap: 30px;
  @media (max-width: 630px) {
    margin: 0 20px 20px 20px;
  }
`;

type Props = {
  search: React.ReactNode;
  result?: React.ReactNode;
};

const VulnerabilityResultTemplate = ({ search, result }: Props) => (
  <StyledWrapper>
    <StyledSearchWrapper>{search}</StyledSearchWrapper>
    <StyledResultWrapper>{result}</StyledResultWrapper>
  </StyledWrapper>
);

export default VulnerabilityResultTemplate;
