import React from 'react';
import styled from 'styled-components';
import background from 'static/searchBackground.png';

const StyledWrapper = styled.div`
  background-image: url(${background});
  background-position: 50% 0;
  background-repeat: no-repeat;
  background-size: 100% 100%;
  height: 100vh;
`;

const StyledContentWrapper = styled.section`
  text-align: center;
  padding-top: 20vh;
  margin: 0 10px;
`;

type Props = {
  children?: React.ReactNode;
};

const VulnerabilityTemplate = ({ children }: Props) => {
  return (
    <StyledWrapper>
      <StyledContentWrapper>{children}</StyledContentWrapper>
    </StyledWrapper>
  );
};

export default VulnerabilityTemplate;
